$MOD51
  ORG        0000H
  JMP        Init
;--------------------------------------------------
	ORG 23H
	jmp	prerus_uart
;--------------------------------------------------

;--------------------------------------------------
LED	equ	P1.2		;vystup LED
;--------------------------------------------------

  ORG        0030H 
;============================================================
; hlavn program
;============================================================
Init:
  	  mov sp,#35H
          mov scon,#01010000B   ;nastaven ser.linky+asovae1
          mov tmod,#00100000B   ;19200 bps,8 databit,1 stopbit,bez parity
          mov 87H,#10000000B    ;zdvojnsoben rychlosti (nastav bit SMOD)
          mov th1,#253          ;asova md 2,ser.linka md 1
	  setb TR1
	  setb	ES		;povol int od uartu ale ne globalne
	  setb	EA		;povol preruseni globalne	
;----------------------------------------------------------------

;=============================Hlavni smycka=================================
main:	setb	LED

zacatek:cpl	LED
	mov R3,#167
cas_1: 	mov R2,#171
cas_2:	mov R1,#16
cas_3: 	djnz R1,cas_3
   	djnz R2,cas_2
   	djnz R3,cas_1
   	sjmp	zacatek
;============================================================================
vysilani:  
          clr ti                  ;nulovn pznaku dokonenho odvysln
          mov sbuf,r0             ;vysln obsahu R0
          jnb ti,$                ;ekn na odvysln
          clr ti                  ;nulovn pznaku dokonenho odvysln
          ret
;------------------------------------------------------------ 
;*************************Obsluha preruseni*************************************
prerus_uart:
	push	ACC		;uloz hodnotu v akumulatoru 
	push	PSW		;uloz stavove slovo
	jnb 	ri,navrat	;prislo preruseni od prijmu ? (muze byt vyvolano i vysilanim)	
	mov	a,sbuf		;nacti hodnotu z UARTU do akumulatoru
	clr	ri		;nuluj flag
;------------------------------------------------------------
	mov	R0,#'('
	call	vysilani
	mov	R0,ACC		;prijatou hodnotu uloz do R0
	call	vysilani	;a odesli
	mov	R0,#')'
	call	vysilani
navrat:
	pop	PSW
	pop	ACC
	reti
;------------------------------------------------------------

 END
